##							-*- Autoconf -*-

# _MST_DOSUBST
#----------
# generate mk-dosubst, which creates dosubst.in from autoconf -t
AC_DEFUN([_MST_DOSUBST],
cat > mk-dosubst <<'EOF_DOSUBST'
#!perl
print <<'EOF';

package veval;

sub main::veval(@S|@) {
   my @S|@s = shift; @S|@s =~ s/@/\\@/g;
   @S|@s =~ s/\@S|@\@S|@/\\\@S|@/g;
   @S|@s =~ s/"/\\"/g;
   my (@S|@ret, @S|@nret ) = (@S|@s);
     @S|@ret = @S|@nret while @S|@ret ne (@S|@nret = eval qq@<:@qq@<:@@S|@ret@:>@@:>@);
   return @S|@ret
}

package main;
use Symbol 'qualify_to_ref';


%subst = (
EOF

foreach ( <STDIN> ) {
    chomp;
    print qq!    @S|@_ => q@<:@\@@S|@_\@\@:>@,\n!;
}
print <<'EOF';
);


*{qualify_to_ref(@S|@_, 'veval')} = \(@S|@subst{@S|@_}) foreach keys %subst;

@S|@subst{"@S|@{_}_EVAL"} = veval @S|@subst{@S|@_} foreach keys %subst;

while( @ARGV && @S|@ARGV@<:@0@:>@ =~ /(.*)=(.*)/ ) {
  @S|@subst{@S|@1} = @S|@2;
  shift;
}

@S|@re = join( '|', sort keys %subst );

while(<>) { s/@<:@@@:>@(@S|@re)@<:@@@:>@/@S|@subst{@S|@1}/geo; print; }
EOF
EOF_DOSUBST
)

# MST_DOSUBST
#------------------
# Wrapper around _MST_DOSUBST so it is called just once
AC_DEFUN([MST_DOSUBST],
[AC_REQUIRE([_MST_DOSUBST])
])# MST_DOSUBST
